<script>
	export let xScale;
	export let subplotLayout;
	export let clip_path_url;
	$: leftMargin = xScale.range()[0];
	$: rightMargin = xScale.range()[1];

	function getNested(obj, ...args) {
		return args.reduce((obj, level) => obj && obj[level], obj)
	}

	let annot_lines = [];
	let annot_text_items = [];
	let annot_background_colors = [];

	$: {
		annot_background_colors = getNested(subplotLayout, "annot_options", "annot_background_colors");
	    annot_lines = getNested(subplotLayout, "annot_options", "annot_horizontal_grid_lines");
	    annot_text_items = getNested(subplotLayout, "annot_options", "annot_text_items");
		if (!annot_lines) { annot_lines = []; }
		if (!annot_text_items) { annot_text_items = []; }
		if (!annot_background_colors) { annot_background_colors = []; }
	}

	let annot_font_height = 11;
		// if (annot_text_items) {
		// 	console.log(annot_text_items);
		// 	; //Math.min(12, (subplotLayout.yScale(annot_text_items[0][0]) - subplotLayout.yScale(annot_text_items[1][0]))*0.7) + "px";
		// 	console.log(annot_font_height);
		// } else {
		// 	let annot_font_height = "10px";
		// }
</script>

<g class="xray_flux_scale_annotation">
	{#each annot_lines as annot_line}
		<line x1={leftMargin}
			  x2={rightMargin}
			  y1={subplotLayout.yScale(annot_line.y)}
			  y2={subplotLayout.yScale(annot_line.y)}
			  stroke="black"
			  stroke-width="0.5px"
			  stroke-opacity="50%"
			  clip-path={clip_path_url}/>
	{/each}
	{#each annot_text_items as annot_text_item}
		<text x={rightMargin-7}
		      y={subplotLayout.yScale(annot_text_item.y)}
			  font-family="sans-serif"
			  font-size={annot_font_height}
			  text-anchor="end"
			  alignment-baseline="middle"
			  clip-path={clip_path_url}>
			  {annot_text_item.text}
		</text>

	{/each}
</g>
